﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using Telerik.Charting;
using Telerik.WinControls.UI;

namespace RadChartViewExample
{
    public partial class Form1 : Form
    {
        private Random rnd = new Random();

        public Form1()
        {
            InitializeComponent();

            DateTimeContinuousAxis xAxis = new DateTimeContinuousAxis();
            xAxis.AxisType = AxisType.First;
            xAxis.LabelFormat = "{0:dd/MM/yyyy}";
            xAxis.LabelFitMode = AxisLabelFitMode.Rotate;
            xAxis.MajorStep = 1.0d;
            xAxis.MajorStepUnit = TimeInterval.Day;
            xAxis.LastLabelVisibility = AxisLastLabelVisibility.Hidden;
            LinearAxis yAxis = new LinearAxis();
            yAxis.AxisType = AxisType.Second;
            yAxis.LabelFormatProvider = new MyTimeSpanLabelFormatProvider();
            
            BarSeries series = new BarSeries();
            for (int i = 0; i < 10; i++)
            {
                CategoricalDataPoint point = new CategoricalDataPoint();
                point.Category = DateTime.Now.AddDays(i);
                point.Value = i * 13 + 5;

                if ((i + 1) % 3 == 0)
                {
                    point.Value = 0;
                }

                series.DataPoints.Add(point);
            }

            series.HorizontalAxis = xAxis;           
            series.VerticalAxis = yAxis;

            this.radChartView1.Series.Add(series);

            BarSeries series2 = new BarSeries();
            for (int i = 0; i < 10; i++)
            {
                CategoricalDataPoint point = new CategoricalDataPoint();
                point.Category = DateTime.Now.AddDays(i);
                point.Value = 12 + i * 7;

                series2.DataPoints.Add(point);
            }

            this.radChartView1.Series.Add(series2);
        }
    }

    public class MyTimeSpanLabelFormatProvider : IFormatProvider, ICustomFormatter
    {
        public object GetFormat(Type formatType)
        {
            if (formatType == typeof(ICustomFormatter))
            {
                return this;
            }

            return null;
        }

        public string Format(string format, object arg, IFormatProvider formatProvider)
        {
            int totalMinutes = int.Parse(arg.ToString());

            return string.Format("{0:00}:{1:00}", totalMinutes / 60, totalMinutes % 60);
        }
    }
}
